#!/bin/bash
usage="$0 -u <username> -p <port>"
while getopts "du:p:" options; do
  case $options in
    u ) user=$OPTARG;;
    d ) daemon=1;;
    p ) port=$OPTARG;;
    ? ) echo $usage
         exit 1;;
    * ) echo $usage
          exit 1;;

  esac
done
if [ "$user" != "" ] ; then
userflag=`grep -E "$user" /etc/passwd 1> /dev/null 2> /dev/null`
if [ $? -eq 0 ] ; then
echo "#!/bin/bash" >> /opt/uptime-agent/tmp/safe.new.user.$$
echo "USER=\"$user\"" >> /opt/uptime-agent/tmp/safe.new.user.$$
egrep -v "^USER=.*|^\#\!\/bin\/bash" /opt/uptime-agent/bin/uptmagnt_daemon_sh >> /opt/uptime-agent/tmp/safe.$$
cat /opt/uptime-agent/tmp/safe.new.user.$$ /opt/uptime-agent/tmp/safe.$$ > /opt/uptime-agent/bin/uptmagnt_daemon_sh 
chmod +x /opt/uptime-agent/bin/uptmagnt_daemon_sh

rm /opt/uptime-agent/tmp/safe.$$
rm /opt/uptime-agent/tmp/safe.new.user.$$
inetprocess=`ps xao "comm" | grep -v "grep" | grep inetd | /usr/bin/awk ' { print $NF } '`
processnum=`ps xao "comm pid" | grep -v "grep" | grep inetd | /usr/bin/awk ' { print $NF } '`
processname=`basename $inetprocess 2>/dev/null`

if [ "$processname" == "xinetd" ] ; then
flag=1
    cat >/etc/xinetd.d/uptmagnt <<EOT
service uptmagnt
{
        disable         = no
        flags           = REUSE
        socket_type     = stream
        wait            = no
        user            = $user
        server          = /opt/uptime-agent/bin/uptmagnt
}
EOT
fi
if [ "$processname" == "inetd" -o "$processname" = "inetutils-inetd" ] ; then

echo "Adding uptmagnt to the inetd.conf file"
previnst=`grep "^uptmagnt" /etc/inetd.conf`  # -- check if agent was installed before
if [ $? -ne 0 ]; then
  fgrep -v uptmagnt /etc/inetd.conf >/tmp/inetd.tmp
  cat >>/tmp/inetd.tmp <<EOT
# *** Installed by the up.time agent installer
uptmagnt        stream tcp nowait $user /opt/uptime-agent/bin/uptmagnt uptmagnt
EOT

  mv /tmp/inetd.tmp /etc/inetd.conf
  chmod 644 /etc/inetd.conf
fi
  flag=1
fi

 
if [ "$flag" != "1" ] ; then
if [ "$port" == "" ] ; then 
inetprocess=`ps xao "comm" | grep -v "grep" | grep uptmagnt-daemon | /usr/bin/awk ' { print $NF } '`
processname=`basename $inetprocess 2>/dev/null`
	if [ "$processname" == "uptmagnt-daemon" ] ; then
	echo "*** Restarting the uptime agent daemon please wait ***"  >> /opt/uptime-agent/logs/install.log
	echo "*** Restarting the uptime agent dagemon please wait ***" 
	echo "***  You may have to wait for this port to be free before changes will take effect***"
	sleep 2
	/opt/uptime-agent/bin/uptmagnt_daemon_sh stop
	sleep 2
	/opt/uptime-agent/bin/uptmagnt_daemon_sh start
	else
	echo "Sorry you do not have xinetd or inetd please install the super server process" >> /opt/uptime-agent/logs/install.log
	echo "***************************************************************************************"
	echo "** Sorry you do not have xinetd or inetd please install the super server process     **"
	echo "** If you prefer not to install the xinetd service please see the README.txt         **"
	echo "** there is a up.time daemon that can be ran instead                                 **"
	echo "***************************************************************************************"
	echo "-- Sleeping for 3 seconds"
	sleep 3
	fi
	fi
else 
if [ "$port" == "" ] ; then
kill -HUP $processnum
fi
fi
chown $user /opt/uptime-agent/bin/uptmagnt_daemon
chown $user /opt/uptime-agent/bin/uptmagnt_daemon_sh
chown $user /opt/uptime_agent/bin/safe_uptmagnt
chown $user /opt/uptime-agent/bin/uptmagnt
chown $user /opt/uptime-agent/bin/perfparse.sh
chown $user /opt/uptime-agent/bin/bsdsysv
chown $user /opt/uptime-agent/bin/psinfo
chown $user /opt/uptime-agent/bin/sysinfo.sh
chown $user /opt/uptime-agent/bin/iostat
chown $user /opt/uptime-agent/bin/sar
chown $user /opt/uptime-agent/bin/mpstat
chown root /opt/uptime-agent/sadc
chmod u+s /opt/uptime-agent/sadc
chown $user /opt/uptime-agent/bin/agent-configure.sh
chown -R $user /opt/uptime-agent/tmp
else
echo "You have to add the user $user"
fi
fi
if [ "$port" != "" ] ; then
	if [ $(echo $port | grep -E "^[0-9]+$") ] ; then
	previnst=`grep "^uptmagnt" /etc/services`  # -- check if agent was installed before
  	fgrep -v uptmagnt /etc/services >/tmp/serv.tmp
  	cat >>/tmp/serv.tmp <<EOT
uptmagnt        ${port}/tcp    # up.time agent
EOT

	echo "#!/bin/bash" >> /opt/uptime-agent/tmp/safe.new.user.$$
	echo "PORT=\"$port\"" >> /opt/uptime-agent/tmp/safe.new.user.$$
	egrep -v "^PORT=.*|^\#\!\/bin\/bash" /opt/uptime-agent/bin/safe_uptmagnt >> /opt/uptime-agent/tmp/safe.$$
	cat /opt/uptime-agent/tmp/safe.new.user.$$ /opt/uptime-agent/tmp/safe.$$ > /opt/uptime-agent/bin/safe_uptmagnt
	chmod +x /opt/uptime-agent/bin/safe_uptmagnt

	rm /opt/uptime-agent/tmp/safe.$$
	rm /opt/uptime-agent/tmp/safe.new.user.$$
  	mv /tmp/serv.tmp /etc/services
  	chmod 644 /etc/services
	`ps xao "comm" | grep -v "grep" | grep inetd > /dev/null`
	if [ "$?" == "1" ] ; then
inetprocess=`ps xao "comm" | grep -v "grep" | grep uptmagnt-daemon | /usr/bin/awk ' { print $NF } '`
processname=`basename $inetprocess 2>/dev/null`
	 if [ "$processname" == "uptmagnt-daemon" ] ; then
	 echo "*** Restarting the uptmagnt_daemon please wait ***"  >> /opt/uptime-agent/logs/install.log
	 echo "*** Restarting the uptmagnt_daemon please wait ***" 
	 echo "***  You may have to wait for this port to be free before changes will take effect***"
	 sleep 2
	 /opt/uptime-agent/bin/uptmagnt_daemon_sh stop
	 sleep 2
	 /opt/uptime-agent/bin/uptmagnt_daemon_sh start
	 else
	 echo "Sorry you do not have xinetd or inetd please install the super server process" >> /opt/uptime-agent/logs/install.log
	 echo "***************************************************************************************"
	 echo "** Sorry you do not have xinetd or inetd please install the super server process     **"
	 echo "** If you prefer not to install the xinetd service please see the README.txt         **"
	 echo "** there is a up.time daemon that can be ran instead                                 **"
	 echo "***************************************************************************************"
	 echo "-- Sleeping for 3 seconds"
 	sleep 3
	 fi
else
processnum=`ps xao "comm pid" | grep -v "grep" | grep inetd | /usr/bin/awk ' { print $NF } '`
kill -HUP $processnum
fi
else
	echo "Port must be all numeric"
exit 1
	fi
fi
