#!/bin/bash
OUTPUTDIR=/opt/uptime-agent/log
VMSTAT=/usr/bin/vmstat
UPTIME_DIR=/opt/uptime-agent 
SARBIN=$UPTIME_DIR/bin/sar
IOSTATBIN=$UPTIME_DIR/bin/iostat
NETSTATBIN=/bin/netstat
JOINBIN=/usr/bin/join
DFBIN="df -lk"


if [ -x /bin/awk ] ; then
	AWKBIN=/bin/awk
else
	AWKBIN=/usr/bin/awk
fi
if [ ! -e $AWKBIN ] ; then
echo "Can Not Find AWK ..... exiting" >> $OUTPUTDIR/testscripts.$$.txt
exit 2
fi
if [ ! -e $SAR ] ; then
	echo " Error Program SAR missing"
        exit 2
fi

# *********************** Testing SysInfo Script ***************************
echo "****** Testing Sysinfo Files"  
echo "Sysinfo Script" > $OUTPUTDIR/testscripts.$$.txt
echo "****************************************" >> $OUTPUTDIR/testscripts.$$.txt
/opt/uptime-agent/bin/sysinfo.sh  >> $OUTPUTDIR/testscripts.$$.txt
echo "****** End of output for sysinfo.sh" >> $OUTPUTDIR/testscripts.$$.txt

echo >> $OUTPUTDIR/testscripts.$$.txt
echo "         *********** Testing To See if OS release file is there ***********" >> $OUTPUTDIR/testscripts.$$.txt 
echo "-------- Contents of OS Release file --------" >> $OUTPUTDIR/testscripts.$$.txt
if [ -e /proc/sys/kernel/osrelease ] ; then
        cat /proc/sys/kernel/osrelease | $AWKBIN '{ print "         -- ",$0 }' >> $OUTPUTDIR/testscripts.$$.txt
else
        echo "-- OS Release File not there"
 
fi
echo "-----------------------------------------------" >> $OUTPUTDIR/testscripts.$$.txt
if [ -e /proc/cpuinfo ] ; then 
       echo "          ----- output of /proc/cpuinfo -----  " >> $OUTPUTDIR/testscripts.$$.txt
       cat /proc/cpuinfo | $AWKBIN ' { print "             ",$0 }' >> $OUTPUTDIR/testscripts.$$.txt
else
       echo "          ---- No /proc/cpuinfo ---- " >> $OUTPUTDIR/testscripts.$$.txt
fi
echo "-----------------------------------------------" >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt

if [ -e /proc/meminfo ] ; then 
       echo "          ----- Contents of /proc/meminfo ----- " >> $OUTPUTDIR/testscripts.$$.txt
       cat /proc/meminfo | $AWKBIN ' { print "             ",$0 }' >> $OUTPUTDIR/testscripts.$$.txt
else
       echo "          ---- No /proc/meminfo ----" >> $OUTPUTDIR/testscripts.$$.txt
fi
echo "-----------------------------------------------" >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt 
if [ -e /proc/sys/vm/page-cluster ] ; then 
       echo "          ---- contents of /proc/sys/vm/page-cluster ---- " >> $OUTPUTDIR/testscripts.$$.txt
       cat /proc/sys/vm/page-cluster >> $OUTPUTDIR/testscripts.$$.txt
else
       echo "          ---- No /proc/sys/vm/page-cluster ---- " >> $OUTPUTDIR/testscripts.$$.txt
fi 
echo "-----------------------------------------------" >> $OUTPUTDIR/testscripts.$$.txt
echo " ************ Testing PerfParse Functions **************" >> $OUTPUTDIR/testscripts.$$.txt
echo "****** Checking perfparse cpu "
echo >> $OUTPUTDIR/testscripts.$$.txt
echo " ---- Contents of perfparse.sh cpu --- " >> $OUTPUTDIR/testscripts.$$.txt
$UPTIME_DIR/bin/perfparse.sh cpu  >> $OUTPUTDIR/testscripts.$$.txt
echo "-------- contents of VMSTAT --------      " >> $OUTPUTDIR/testscripts.$$.txt
if [ -e $VMSTAT ] ; then 
	echo "         -- VM Stat Exists" >> $OUTPUTDIR/testscripts.$$.txt
        echo "         -- Output looks like this" >> $OUTPUTDIR/testscripts.$$.txt
        $VMSTAT >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
else
    	echo "        -- vmstat does not exist or invalid path" >>$OUTPUTDIR/testscripts.$$.txt
fi    
echo >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo "----- Contents of  $SARBIN -urwqR 1 ------    " >> $OUTPUTDIR/testscripts.$$.txt
$SARBIN -urWqR 1 | $AWKBIN '{ print "              ",$0 }' >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "****** Checking Perfparse disk stats "
echo " ---- contents of perfparse.sh disk ----- " >> $OUTPUTDIR/testscripts.$$.txt
$UPTIME_DIR/bin/perfparse.sh disk >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo " ---- contents of running  $IOSTATBIN -d -x 1 2 ----- " >> $OUTPUTDIR/testscripts.$$.txt 
echo >> $OUTPUTDIR/testscripts.$$.txt
$IOSTATBIN -d -x 1 2 >>  $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "****** Checking Perfparse Multi CPU stats "
echo " ------ Contents of perfparse.sh mpstat ----- "  >> $OUTPUTDIR/testscripts.$$.txt
echo  >> $OUTPUTDIR/testscripts.$$.txt
$UPTIME_DIR/bin/perfparse.sh mpstat >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo "----- contents of  running $SARBIN -P ALL 1 2  ------" >> $OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
$SARBIN -P ALL 1 2 >> $OUTPUTDIR/testscripts.$$.txt 2>>$OUTPUTDIR/testscripts.$$.txt
echo >> $OUTPUTDIR/testscripts.$$.txt
echo "****** Processing Netstats"
echo "--- contents of perfparse.sh netstat ----" >> $OUTPUTDIR/testscripts.$$.txt
$UPTIME_DIR/bin/perfparse.sh netstat >> $OUTPUTDIR/testscripts.$$.txt
echo " ------ Contents of $NETSTATBIN -s -------">> $OUTPUTDIR/testscripts.$$.txt
$NETSTATBIN -s >> $OUTPUTDIR/testscripts.$$.txt
echo "****** Checking Misc Items "
echo " ----- Listing of /opt/uptime-agent/bin ------ " >> $OUTPUTDIR/testscripts.$$.txt
ls -la /opt/uptime-agent/bin >> $OUTPUTDIR/testscripts.$$.txt
echo " ----- Listing of /opt/uptime-agent/tmp ------ " >> $OUTPUTDIR/testscripts.$$.txt
ls -la /opt/uptime-agent/tmp >> $OUTPUTDIR/testscripts.$$.txt
echo " ---- Contents of df-k ----" >> $OUTPUTDIR/testscripts.$$.txt
df -k >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "----------------------------">> $OUTPUTDIR/testscripts.$$.txt
echo '----- Contents of ps -eo "user pid args"  ----' >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
ps -eo "user pid args" >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "----------------------------" >> $OUTPUTDIR/testscripts.$$.txt
echo "------  contents of who -----------------" >> $OUTPUTDIR/testscripts.$$.txt
who >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "---------------------------------------" >> $OUTPUTDIR/testscripts.$$.txt
echo "------- Contents of last ----------" >> $OUTPUTDIR/testscripts.$$.txt
last  >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "-----------------------------------" >> $OUTPUTDIR/testscripts.$$.txt
echo "-------- Contents of tail -5 /var/log/messages --------" >> $OUTPUTDIR/testscripts.$$.txt
tail -5 /var/log/messages >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "---- Contents of servicies -----" >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
cat /etc/services | grep "uptmagnt" >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
echo "---- contents of inetd.conf ---- " >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt 
cat /etc/inetd.conf | grep "uptmagnt" >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
if [ -d /etc/xinetd.d ] ; then
	echo "--- Contents of xinetd.d directory ---" >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
	ls -la /etc/xinetd.d >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
        if [ -e /etc/xinetd.d/uptmagnt ] ; then
        echo " ---- contents of /etc/xinetd.d/uptmagnt ----" >> $OUTPUTDIR/testscripts.$$.txt
        cat /etc/xinetd.d/uptmagnt >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
        else
        echo "---- No uptmagnt in xinetd.d ---- " >> $OUTPUTDIR/testscripts.$$.txt 2>> $OUTPUTDIR/testscripts.$$.txt
        fi
fi
if [ ! -d /etc/xinetd.d -a ! -e /etc/inetd.conf ] ; then
	echo "This agent does not have xinetd.d or inetd.conf" >> $OUTPUTDIR/testscripts.$$.txt
fi
echo "**** Please send SUPPORT the file located in $OUTPUTDIR/testscripts.$$.txt ********"
